#ifndef PARSER_H
#define PARSER_H

#include <iostream>
#include <string>
#include <sstream>
#include <vector>

#include "headers.h"
#include "worldmodel.h"
#include "bodymodel.h"
#include "visionsense.h"

using namespace std;

class Parser{

 private:

  WorldModel *worldModel;
  BodyModel *bodyModel;
  VisionSense *visionSense;

  int uNum;
  int side;

  string teamName;

 protected:
  
  vector<string> tokenise(const string &s);
  bool parseTime(const string &str);
  bool parseGameState(const string &str);
  bool parseGyro(const string &str);
  bool parseHear(const string &str);
  bool parseHingeJoint(const string &str);
  bool parseSee(const string &str);
  bool parseGoalPost(const string &str);
  bool parseFlag(const string &str);
  bool parseBall(const string &str);
  bool parsePlayer(const string &str);
  bool parseFRP(const string &str);
  vector<string> segment(const string &str, const bool &omitEnds);
  void processVision();
  
 public:
  
  Parser(WorldModel *worldModel, BodyModel *bodyModel, const string &teamName);
  ~Parser();

  bool parse(const string &input);
};

#endif // PARSER_H

