#include "naobehavior.h"

string NaoBehavior::composeAction(){
    
  stringstream ss("");
  
  ss << "(he1 " << bodyModel->computeTorque(EFF_H1) << ")";
  ss << "(he2 " << bodyModel->computeTorque(EFF_H2) << ")";
  
  ss << "(lae1 " << bodyModel->computeTorque(EFF_LA1) << ")";
  ss << "(lae2 " << bodyModel->computeTorque(EFF_LA2) << ")";
  ss << "(lae3 " << bodyModel->computeTorque(EFF_LA3) << ")";
  ss << "(lae4 " << bodyModel->computeTorque(EFF_LA4) << ")";
  
  ss << "(rae1 " << bodyModel->computeTorque(EFF_RA1) << ")";
  ss << "(rae2 " << bodyModel->computeTorque(EFF_RA2) << ")";
  ss << "(rae3 " << bodyModel->computeTorque(EFF_RA3) << ")";
  ss << "(rae4 " << bodyModel->computeTorque(EFF_RA4) << ")";

  ss << "(lle1 " << bodyModel->computeTorque(EFF_LL1) << ")";
  ss << "(lle2 " << bodyModel->computeTorque(EFF_LL2) << ")";
  ss << "(lle3 " << bodyModel->computeTorque(EFF_LL3) << ")";
  ss << "(lle4 " << bodyModel->computeTorque(EFF_LL4) << ")";
  ss << "(lle5 " << bodyModel->computeTorque(EFF_LL5) << ")";
  ss << "(lle6 " << bodyModel->computeTorque(EFF_LL6) << ")";
  
  ss << "(rle1 " << bodyModel->computeTorque(EFF_RL1) << ")";
  ss << "(rle2 " << bodyModel->computeTorque(EFF_RL2) << ")";
  ss << "(rle3 " << bodyModel->computeTorque(EFF_RL3) << ")";
  ss << "(rle4 " << bodyModel->computeTorque(EFF_RL4) << ")";
  ss << "(rle5 " << bodyModel->computeTorque(EFF_RL5) << ")";
  ss << "(rle6 " << bodyModel->computeTorque(EFF_RL6) << ")";

  //  ss << "(say Shivaram)";

  return ss.str();
}

void NaoBehavior::checkAngles(){

  //    for(int i = 0; i < EFF_NUM; i++){
  //        bodyModel->setTargetAngle(i, 0);
  //        bodyModel->setOperationMode(i, EFF_OP_TARGET_ANGLE);
  //    }
    
    double gotAngle;

    //bodyModel->setTargetAngle(EFF_H1, -40.0);
    //gotAngle = bodyModel->getJointAngle(HJ_H1);

    //bodyModel->setTargetAngle(EFF_H2, 0);
    //gotAngle = bodyModel->getJointAngle(HJ_H2);

    //bodyModel->setTargetAngle(EFF_LA1, -20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LA1);

    //bodyModel->setTargetAngle(EFF_LA2, 80.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LA2);
    
    //bodyModel->setTargetAngle(EFF_LA3, 20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LA3);
    
    //bodyModel->setTargetAngle(EFF_LA4, -80.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LA4);

    //bodyModel->setTargetAngle(EFF_RA1, 20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RA1);

    //bodyModel->setTargetAngle(EFF_RA2, -80.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RA2);
    
    //bodyModel->setTargetAngle(EFF_RA3, -20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RA3);
    
    //bodyModel->setTargetAngle(EFF_RA4, 80.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RA4);
    
    //bodyModel->setTargetAngle(EFF_LL1, -90.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL1);

    //bodyModel->setTargetAngle(EFF_LL2, 20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL2);

    //bodyModel->setTargetAngle(EFF_LL3, -20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL3);

    //bodyModel->setTargetAngle(EFF_LL4, 40.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL4);

    //bodyModel->setTargetAngle(EFF_LL5, -40.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL5);

    //bodyModel->setTargetAngle(EFF_LL6, 20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_LL6);

    //bodyModel->setTargetAngle(EFF_RL1, -90.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RL1);

    //    bodyModel->setTargetAngle(EFF_RL2, 90.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RL2);

    //bodyModel->setTargetAngle(EFF_RL3, 90.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RL3);

    //bodyModel->setTargetAngle(EFF_RL4, -20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RL4);

    //bodyModel->setTargetAngle(EFF_RL5, 20.0);
    //gotAngle = bodyModel->getJointAngle(HJ_RL5);

    bodyModel->setTargetAngle(EFF_RL6, -20.0);
    gotAngle = bodyModel->getJointAngle(HJ_RL6);

    std::cout << "Got Angle: " << gotAngle << "\n";
    
}

bool NaoBehavior::setInitialHead(){

  bool reached;

  bodyModel->setTargetAngle(EFF_H1, 0);
  bodyModel->setTargetAngle(EFF_H2, 0);

  reached = bodyModel->getTargetReached(EFF_H1) && bodyModel->getTargetReached(EFF_H2);
  return reached;
}

bool NaoBehavior::setInitialArm(const int &arm){

  bool reached;

  double ang1, ang2, ang3, ang4;

  ang1 = -50.0;
  ang2 = 30.0;
  ang3 = 0;
  ang4 = -50.0;

  if(arm == ARM_LEFT){

    bodyModel->setTargetAngle(EFF_LA1, ang1);
    bodyModel->setTargetAngle(EFF_LA2, ang2);
    bodyModel->setTargetAngle(EFF_LA3, ang3);
    bodyModel->setTargetAngle(EFF_LA4, ang4);

    reached = bodyModel->getTargetReached(EFF_LA1) && bodyModel->getTargetReached(EFF_LA2) && bodyModel->getTargetReached(EFF_LA3) && bodyModel->getTargetReached(EFF_LA4);

  }
  else{//ARM_RIGHT

    bodyModel->setTargetAngle(EFF_RA1, ang1);
    bodyModel->setTargetAngle(EFF_RA2, -ang2);
    bodyModel->setTargetAngle(EFF_RA3, -ang3);
    bodyModel->setTargetAngle(EFF_RA4, -ang4);

    reached = bodyModel->getTargetReached(EFF_RA1) && bodyModel->getTargetReached(EFF_RA2) && bodyModel->getTargetReached(EFF_RA3) && bodyModel->getTargetReached(EFF_RA4);

  }

  return reached;
}

bool NaoBehavior::setInitialLeg(const int &leg){

  bool reached;

  double ang1 = 0;
  double ang2 = 6.0;
  double ang3 = 18.0;
  double ang4 = -30.0;
  double ang5 = 18.0;
  double ang6 = -6.0;

  if(leg == LEG_LEFT){

    bodyModel->setTargetAngle(EFF_LL1, ang1);
    bodyModel->setTargetAngle(EFF_LL2, ang2);
    bodyModel->setTargetAngle(EFF_LL3, ang3);
    bodyModel->setTargetAngle(EFF_LL4, ang4);
    bodyModel->setTargetAngle(EFF_LL5, ang5);
    bodyModel->setTargetAngle(EFF_LL6, ang6);

    reached = bodyModel->getTargetReached(EFF_LL1) && bodyModel->getTargetReached(EFF_LL2) && bodyModel->getTargetReached(EFF_LL3) && bodyModel->getTargetReached(EFF_LL4) && bodyModel->getTargetReached(EFF_LL5) && bodyModel->getTargetReached(EFF_LL6);

  }
  else{

    bodyModel->setTargetAngle(EFF_RL1, ang1);
    bodyModel->setTargetAngle(EFF_RL2, -ang2);
    bodyModel->setTargetAngle(EFF_RL3, ang3);
    bodyModel->setTargetAngle(EFF_RL4, ang4);
    bodyModel->setTargetAngle(EFF_RL5, ang5);
    bodyModel->setTargetAngle(EFF_RL6, -ang6);

    reached = bodyModel->getTargetReached(EFF_RL1) && bodyModel->getTargetReached(EFF_RL2) && bodyModel->getTargetReached(EFF_RL3) && bodyModel->getTargetReached(EFF_RL4) && bodyModel->getTargetReached(EFF_RL5) && bodyModel->getTargetReached(EFF_RL6);
  }

  return reached;
}

