#ifndef _FIELD_H
#define _FIELD_H

#include "WorldObject.h"
#include "Geometry.h"
#include <stdio.h> 

//#ifdef interface_H
//cout << "Field_h";
//#endif


// setup constants for field size, landmark locations, etc
// New Field

const double FIELD_Y = 12; // 4000; //3600;
const double FIELD_X = 18; // 6000; //5400;
//const double GRASS_Y = 4725; //4000;  // This is the area in which the robots
//const double GRASS_X = 6725; // are assumed to be.

const double HALF_FIELD_Y = FIELD_Y/2.0;
const double HALF_FIELD_X = FIELD_X/2.0;
//const double HALF_GRASS_Y = GRASS_Y/2.0;
//const double HALF_GRASS_X = GRASS_X/2.0;

const double GOAL_Y = 2.1;    // width
const double GOAL_X = .6;     // depth
const double GOAL_Z = .8;      // height
const double HALF_GOAL_Y = GOAL_Y / 2;
//const double HALF_GOAL_X = GOAL_X / 2;
//const double GOAL_WIDTH = GOAL_Y;
//const double GOAL_DEPTH = GOAL_X;
//const double GOAL_HEIGHT = GOAL_Z;
//const double BORDER_OFFSET = 150;
//const double GOAL_OFFSET   = 50;
//const double PENALTY_Y = 3000;
//const double PENALTY_X =  600;
//const double CIRCLE_RADIUS =  620; //180;
//const double LINE_WIDTH = 50;
//
//const double FIELD_LINE_WIDTH =     50; //25;
//const double BEACON_HEIGHT       = 200;
//const double BEACON_LOWER_HEIGHT = 200; 
//const double BEACON_UPPER_HEIGHT = 400;
//const double GOAL_HEIGHT =    800; //400;
//const double BALL_HEIGHT =          85;
//
//const double ROBOT_HEIGHT =   520; //   570;

const double FIELD_CENTER_X = 0;
const double FIELD_CENTER_Y = 0;

// SIM FIELD
//const double FIELD_Y = 4000; //3600;
//const double FIELD_X = 6000; //5400;
//const double GRASS_Y = 4400; //4000;  // This is the area in which the robots
//const double GRASS_X = 6800;  // are assumed to be.

//const double HALF_FIELD_Y = FIELD_Y/2.0;
//const double HALF_FIELD_X = FIELD_X/2.0;
//const double HALF_GRASS_Y = GRASS_Y/2.0;
//const double HALF_GRASS_X = GRASS_X/2.0;

//const double GOAL_Y = 1400;    // width
//const double GOAL_X = 400;
//const double BORDER_OFFSET = 150;
//const double GOAL_OFFSET   = 50;
//const double PENALTY_Y = 2000;
//const double PENALTY_X =  600;
//const double CIRCLE_RADIUS =  650; //180;
//const double LINE_WIDTH = 50;

//const double FIELD_LINE_WIDTH =     50; //25;
//const double BEACON_HEIGHT       = 200;
//const double BEACON_LOWER_HEIGHT = 200; 
//const double BEACON_UPPER_HEIGHT = 400;
//const double GOAL_HEIGHT =    800; //400;
//const double BALL_HEIGHT =          85;

//const double ROBOT_HEIGHT =   520; //   570;

//const double FIELD_CENTER_X = 0;
//const double FIELD_CENTER_Y = 0;

//const double CIRCLE_HEX_LENGTH = 2.0*(CIRCLE_RADIUS*sin(DEG_T_RAD*30.0));

// Some rectangles

const Rectangle FIELD = 
Rectangle( Point2D( -FIELD_X / 2,  FIELD_Y / 2 ),
	   Point2D(  FIELD_X / 2, -FIELD_Y / 2 ) );
// We don't want to limit our particles to inside the boundary
// So this area is two times larger
const Rectangle GRASS = 
Rectangle( Point2D( -FIELD_X ,  FIELD_Y  ),
	   Point2D(  FIELD_X , -FIELD_Y  ) );

//const Rectangle GRASS = 
//Rectangle( Point2D( -GRASS_X / 2,  GRASS_Y / 2 ),
//	   Point2D(  GRASS_X / 2, -GRASS_Y / 2 ) );




// Landmark locations
//const Point2D landmarkLocation[] = {
//  Point2D( 0, -FIELD_Y / 2 - BORDER_OFFSET),  // WO_BLUE_YELLOW_BEACON
//  Point2D( 0, FIELD_Y / 2 + BORDER_OFFSET),   // WO_YELLOW_BLUE_BEACON
//
//  Point2D( -FIELD_X / 2, 0),                 // WO_BLUE_GOAL = 7,
//  Point2D( -FIELD_X / 2, -GOAL_Y / 2),       // WO_BLUE_LEFT_GOALPOST = 8,
//  Point2D( -FIELD_X / 2, GOAL_Y / 2),        // WO_BLUE_RIGHT_GOALPOST = 9,
//
//  Point2D( FIELD_X / 2, 0 ),                 // WO_YELLOW_GOAL = 10,
//  Point2D( FIELD_X / 2, GOAL_Y / 2 ),        // WO_YELLOW_LEFT_GOALPOST = 11,
//  Point2D( FIELD_X / 2, -GOAL_Y / 2)         // WO_YELLOW_RIGHT_GOALPOST = 12,
//};
//

// Line intersection locations
//const Point2D intersectionLocation[] = {
//  // L
//  Point2D( FIELD_X / 2, FIELD_Y / 2),                 // 0 WO_YELLOW_FIELD_LEFT_L 
//  Point2D( FIELD_X / 2, -FIELD_Y / 2),                //   WO_YELLOW_FIELD_RIGHT_L
//  Point2D( FIELD_X / 2 - PENALTY_X, PENALTY_Y / 2),   // 2 WO_YELLOW_PEN_LEFT_L
//  Point2D( FIELD_X / 2 - PENALTY_X, -PENALTY_Y / 2),  //   WO_YELLOW_PEN_RIGHT_L
//  Point2D( -FIELD_X / 2 + PENALTY_X, PENALTY_Y / 2),  // 4 WO_BLUE_PEN_RIGHT_L
//  Point2D( -FIELD_X / 2 + PENALTY_X, -PENALTY_Y / 2), //   WO_BLUE_PEN_LEFT_L
//  Point2D( -FIELD_X / 2, FIELD_Y / 2),                // 6 WO_BLUE_FIELD_RIGHT_L
//  Point2D( -FIELD_X / 2, -FIELD_Y / 2),               // 7 WO_BLUE_FIELD_LEFT_L
//
//  // T
//  Point2D( FIELD_X / 2, PENALTY_Y / 2),               // 8  WO_YELLOW_PEN_LEFT_T 
//  Point2D( FIELD_X / 2, -PENALTY_Y / 2),              //    WO_YELLOW_PEN_RIGHT_T
//  Point2D( 0, FIELD_Y / 2),                           // 10 WO_CENTER_TOP_T
//  Point2D( 0, -FIELD_Y / 2),                          //    WO_CENTER_BOTTOM_T,
//  Point2D( -FIELD_X / 2, PENALTY_Y / 2),              // 12 WO_BLUE_PEN_RIGHT_T
//  Point2D( -FIELD_X / 2, -PENALTY_Y / 2),             // 13 WO_BLUE_PEN_LEFT_T
//
//};
//
  
// Line location
//const Line2D lineLocation[] = {
//
//  // HORIZONTAL LINES
//  Line2D( intersectionLocation[0], intersectionLocation[1] ),    // WO_YELLOW_GOAL_LINE
//  Line2D( intersectionLocation[2], intersectionLocation[3] ),    // WO_YELLOW_PENALTY
//  Line2D( intersectionLocation[10], intersectionLocation[11] ),  // WO_CENTER_LINE
//  Line2D( intersectionLocation[4], intersectionLocation[5] ),  // WO_BLUE_PENALTY
//  Line2D( intersectionLocation[6], intersectionLocation[7] ),    // WO_BLUE_GOAL_LINE
//
//  // VERTICAL LINES
//  Line2D( intersectionLocation[0], intersectionLocation[6] ),    // WO_TOP_SIDE_LINE
//  Line2D( intersectionLocation[2], intersectionLocation[4] ),    // WO_PENALTY_TOP
//  Line2D( intersectionLocation[3], intersectionLocation[5] ),    // WO_PENALTY_BOTTOM
//  Line2D( intersectionLocation[1], intersectionLocation[7] )     // WO_BOTTOM_SIDE_LINE
//
//};
//
//// Circle Hex location
//const double circPointAngle=DEG_T_RAD*(360.0/7.0);
//const double NUM_CIRC_LINES = 7;
//const Point2D circlePoints[] = {
// // HORIZONTAL LINES
//  Point2D( CIRCLE_RADIUS*cos(0),  CIRCLE_RADIUS*sin(0)),
//  Point2D( CIRCLE_RADIUS*cos(1*circPointAngle),  CIRCLE_RADIUS*sin(1*circPointAngle)),
//  Point2D( CIRCLE_RADIUS*cos(2*circPointAngle),  CIRCLE_RADIUS*sin(2*circPointAngle)),
//  Point2D( CIRCLE_RADIUS*cos(3*circPointAngle),  CIRCLE_RADIUS*sin(3*circPointAngle)),
//  Point2D( CIRCLE_RADIUS*cos(4*circPointAngle),  CIRCLE_RADIUS*sin(4*circPointAngle)),
//  Point2D( CIRCLE_RADIUS*cos(5*circPointAngle),  CIRCLE_RADIUS*sin(5*circPointAngle)),
//  Point2D( CIRCLE_RADIUS*cos(6*circPointAngle),  CIRCLE_RADIUS*sin(6*circPointAngle)),
//};
//
//
//const Line2D circleLines[] = {
//// HORIZONTAL LINES
//  Line2D( circlePoints[0], circlePoints[1] ),    // WO_YELLOW_GOAL_LINE
//  Line2D( circlePoints[1], circlePoints[2] ),    // WO_YELLOW_PENALTY
//  Line2D( circlePoints[2], circlePoints[3] ),  // WO_CENTER_LINE
//  Line2D( circlePoints[3], circlePoints[4] ),  // WO_BLUE_PENALTY
//  Line2D( circlePoints[4], circlePoints[5] ),  // WO_CENTER_LINE
//  Line2D( circlePoints[5], circlePoints[6] ),  // WO_BLUE_PENALTY
//  Line2D( circlePoints[6], circlePoints[0] ),  // WO_CENTER_LINE
//
//};
//
#endif
