#include "headers.h"

// This file contains mapping between enums to strings, to 
// be used by the parser (mainly) when reading from file 

template<>
EnumParser<BodyParts>::EnumParser()
{
    string2enum["TORSO"] = TORSO;
    enum2String[TORSO] = "TORSO";

    string2enum["HEAD"] = HEAD;
    enum2String[HEAD] = "HEAD";

    string2enum["ARM_LEFT"] = ARM_LEFT;
    enum2String[ARM_LEFT] = "ARM_LEFT";

    string2enum["ARM_RIGHT"] = ARM_RIGHT;
    enum2String[ARM_RIGHT] = "ARM_RIGHT";

    string2enum["LEG_LEFT"] = LEG_LEFT;
    enum2String[LEG_LEFT] = "LEG_LEFT";
    
    string2enum["LEG_RIGHT"] = LEG_RIGHT;
    enum2String[LEG_RIGHT] = "LEG_RIGHT";
}

template<>
EnumParser<SkillType>::EnumParser()
{
    string2enum["SKILL_WALK_FRONT"] = SKILL_WALK_FRONT;
    enum2String[SKILL_WALK_FRONT] = "SKILL_WALK_FRONT";

    string2enum["SKILL_WALK_BACK"] = SKILL_WALK_BACK;
    enum2String[SKILL_WALK_BACK] = "SKILL_WALK_BACK";

    string2enum["SKILL_WALK_LEFT"] = SKILL_WALK_LEFT;
    enum2String[SKILL_WALK_LEFT] = "SKILL_WALK_LEFT";

    string2enum["SKILL_WALK_RIGHT"] = SKILL_WALK_RIGHT;
    enum2String[SKILL_WALK_RIGHT] = "SKILL_WALK_RIGHT";

    string2enum["SKILL_TURN_LEFT"] = SKILL_TURN_LEFT;
    enum2String[SKILL_TURN_LEFT] = "SKILL_TURN_LEFT";

    string2enum["SKILL_TURN_RIGHT"] = SKILL_TURN_RIGHT;
    enum2String[SKILL_TURN_RIGHT] = "SKILL_TURN_RIGHT";

    string2enum["SKILL_KICK_FRONT"] = SKILL_KICK_FRONT;
    enum2String[SKILL_KICK_FRONT] = "SKILL_KICK_FRONT";

    string2enum["SKILL_STAND"] = SKILL_STAND;
    enum2String[SKILL_STAND] = "SKILL_STAND";

    // TODO: this is not a skill - remove (shivaram said)
    string2enum["SKILL_FIND_BALL_LEFT"] = SKILL_FIND_BALL_LEFT;
    enum2String[SKILL_FIND_BALL_LEFT] = "SKILL_FIND_BALL_LEFT";

    string2enum["SKILL_FIND_BALL_RIGHT"] = SKILL_FIND_BALL_RIGHT;
    enum2String[SKILL_FIND_BALL_RIGHT] = "SKILL_FIND_BALL_RIGHT";



    // TODO: added skills in different speeds
    string2enum["SKILL_WALK_FRONT1"] = SKILL_WALK_FRONT1;
    enum2String[SKILL_WALK_FRONT1] = "SKILL_WALK_FRONT1";

    string2enum["SKILL_WALK_FRONT0"] = SKILL_WALK_FRONT0;
    enum2String[SKILL_WALK_FRONT0] = "SKILL_WALK_FRONT0";

}

template<>
EnumParser<Effectors>::EnumParser()
{
    string2enum["EFF_H1"] = EFF_H1;
    enum2String[EFF_H1] = "EFF_H1";

    string2enum["EFF_H2"] = EFF_H2;
    enum2String[EFF_H2] = "EFF_H2";

    string2enum["EFF_LA1"] = EFF_LA1;
    enum2String[EFF_LA1] = "EFF_LA1";

    string2enum["EFF_LA2"] = EFF_LA2;
    enum2String[EFF_LA2] = "EFF_LA2";

    string2enum["EFF_LA3"] = EFF_LA3;
    enum2String[EFF_LA3] = "EFF_LA3";

    string2enum["EFF_LA4"] = EFF_LA4;
    enum2String[EFF_LA4] = "EFF_LA4";

    string2enum["EFF_RA1"] = EFF_RA1;
    enum2String[EFF_RA1] = "EFF_RA1";

    string2enum["EFF_RA2"] = EFF_RA2;
    enum2String[EFF_RA2] = "EFF_RA2";

    string2enum["EFF_RA3"] = EFF_RA3;
    enum2String[EFF_RA3] = "EFF_RA3";

    string2enum["EFF_RA4"] = EFF_RA4;
    enum2String[EFF_RA4] = "EFF_RA4";

    string2enum["EFF_LL1"] = EFF_LL1;
    enum2String[EFF_LL1] = "EFF_LL1";

    string2enum["EFF_LL2"] = EFF_LL2;
    enum2String[EFF_LL2] = "EFF_LL2";

    string2enum["EFF_LL3"] = EFF_LL3;
    enum2String[EFF_LL3] = "EFF_LL3";

    string2enum["EFF_LL4"] = EFF_LL4;
    enum2String[EFF_LL4] = "EFF_LL4";

    string2enum["EFF_LL5"] = EFF_LL5;
    enum2String[EFF_LL5] = "EFF_LL5";

    string2enum["EFF_LL6"] = EFF_LL6;
    enum2String[EFF_LL6] = "EFF_LL6";

    string2enum["EFF_RL1"] = EFF_RL1;
    enum2String[EFF_RL1] = "EFF_RL1";

    string2enum["EFF_RL2"] = EFF_RL2;
    enum2String[EFF_RL2] = "EFF_RL2";

    string2enum["EFF_RL3"] = EFF_RL3;
    enum2String[EFF_RL3] = "EFF_RL3";

    string2enum["EFF_RL4"] = EFF_RL4;
    enum2String[EFF_RL4] = "EFF_RL4";

    string2enum["EFF_RL5"] = EFF_RL5;
    enum2String[EFF_RL5] = "EFF_RL5";

    string2enum["EFF_RL6"] = EFF_RL6;
    enum2String[EFF_RL6] = "EFF_RL6";

}

