#!/usr/bin/perl

use IO::Socket;
use Math::Trig;

sub prepareMsg
{
  my $msg = shift;
  my $len = length($msg);
  my $pref = pack 'N',$len;
  return $pref.$msg;
}
#print "Playmode [BeforeKickOff, KickOff_Left, KickOff_Right, PlayOn, KickIn_Left, KickIn_Right, corner_kick_left,corner_kick_right, goal_kick_left, goal_kick_right, offside_left, offside_right, GameOver, Goal_Left, Goal_Right, free_kick_left, free_kick_right, unknown]: ";
print  "Which goal? (1=left/2=right):";
my $location = <>;

my $host = shift || 'localhost';
my $port = shift || 3200;
my $proto = getprotobyname("tcp");

my $iaddr = inet_aton($host);
my $paddr = sockaddr_in($port, $iaddr);

$/ = "\0";

print "Connecting to server $host:$port...\n";

my $sock = new IO::Socket::INET ( PeerAddr => $host, PeerPort => $port, Proto => 'tcp',  );
die "Could not create socket: $!\n" unless $sock;

print "Done!\n";

my $fieldLength = 0;
my $fieldWidth = 0;
my $goalWidth = 0;

while ($fieldLength == 0) {
  $line = <$sock>;
  if ($line =~ /FieldLength ([\d\.]+).*?FieldWidth ([\d\.]+).*?GoalWidth ([\d\.]+)/) {
    $fieldLength = $1;
    $fieldWidth = $2;
    $goalWidth = $3;
  }
}

print "Field parameters: $fieldLength $fieldWidth $goalWidth\n";
my $y = ($fieldLength/2) - 1;
if ($location == 1){
  $y = $y * -1;
}
print "BallLocation and Velocity: (ball (pos $y 0 0)(vel 0 0 0))\n";
print $sock prepareMsg("(ball (pos $y 0 0)(vel 0 0 0))");
print $sock prepareMsg("(playMode goal_kick_left)");
<$sock>;

#while (<$sock>) {
  #print;
#    my $msg = "(ball (pos $x $y 0.3)(vel $dx $dy $dz))";
#    print $sock prepareMsg($msg);
#    print "$msg\n";
#}



close($sock) or die "Failed closing socket: $!\n";
