#!/usr/bin/perl

# beamball-and-kickoff.pl
# Yinon Bentor (adapted from BATS code)
# yinon@cs.utexas.edu
# 2009-11-27
#
# This perl script will take 3 parameters on the command line:
#   beamball-and-kickoffpl x y z
#
# And beam the ball to that (fixed) position on the field,
# then do a kickoff-left, and then quit.

use IO::Socket;
use Math::Trig;

sub prepareMsg
{
  my $msg = shift;
  my $len = length($msg);
  my $pref = pack 'N',$len;
  return $pref.$msg;
}
#print "Playmode [BeforeKickOff, KickOff_Left, KickOff_Right, PlayOn, KickIn_Left, KickIn_Right, corner_kick_left,corner_kick_right, goal_kick_left, goal_kick_right, offside_left, offside_right, GameOver, Goal_Left, Goal_Right, free_kick_left, free_kick_right, unknown]: ";
#print  "Which goal? (1=left/2=right):";
#my $location = <>;
my $location = 2;

my $host = 'localhost';
my $port = $ENV{'SPARK_SERVERPORT'} || 3200;
my $proto = getprotobyname("tcp");

my $iaddr = inet_aton($host);
my $paddr = sockaddr_in($port, $iaddr);

$/ = "\0";

print "Connecting to server $host:$port...\n";

my $sock = new IO::Socket::INET ( PeerAddr => $host, PeerPort => $port, Proto => 'tcp',  );
die "Could not create socket: $!\n" unless $sock;

print "Done!\n";

#my $fieldLength = 0;
#my $fieldWidth = 0;
#my $goalWidth = 0;
#
#while ($fieldLength == 0) {
#  $line = <$sock>;
#  if ($line =~ /FieldLength ([\d\.]+).*?FieldWidth ([\d\.]+).*?GoalWidth ([\d\.]+)/) {
#    $fieldLength = $1;
#    $fieldWidth = $2;
#    $goalWidth = $3;
#  }
#}
#
#print "Field parameters: FieldLength: $fieldLength FieldWidth: $fieldWidth GoalWidth: $goalWidth\n";

#my $y = ($fieldLength/2) - 1;
#if ($location == 1){
#  $y = $y * -1;
#}


#Read ball position from the command line:
$x = shift;
$y = shift;
$z = shift;

print "BallLocation and Velocity: (ball (pos $x $y $z)(vel 0 0 0))\n";
print $sock prepareMsg("(ball (pos $x $y $z)(vel 0 0 0))");
print $sock prepareMsg("(playMode PlayOn)");
<$sock>;

close($sock) or die "Failed closing socket: $!\n";
