#!/lusr/bin/bash

# This script runs the simspark soccer simulator and an agent 

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/projects/agents2/villasim/rcss3D/server/lib/simspark/:/public/linux/lib/

# Set the agent and monitor port randomly, to allow for multiple agents per machine
# Note: $RANDOM returns a value from 0 to 32767, ports <= 1024 are reserved for root 
export SPARK_SERVERPORT=$[$RANDOM + 1025]
export SPARK_AGENTPORT=$[$RANDOM + 1025]

echo "My parameters: "
cat $1
echo

# semaphors are removed due to port randomization -- we can run multiple sims on the same machine:

#while test `find /tmp/simspark-condor -mmin -1`
#do 
#  # wait for either the file to disappear or for it to grow older
#  # than 1 minute
#  echo "Waiting"
#  sleep 5
#done  

#touch /tmp/simspark-condor

# removing in case we have multiple jobs running on the 
# same machine via port randomization.  we need to watch
# out for zombie agents somehow

# killall -9 agentspark

echo -n "It is: "
date
echo -n "and I am on: "
hostname
echo "Agent port: $SPARK_AGENTPORT, Monitor port: $SPARK_SERVERPORT"

/projects/agents2/villasim/rcss3D/server/bin/simspark &
PID=$!

sleep 2
# TODO: temporary fix!! get rid of it - because relative path dependency of skills
cd `dirname $0`/..
`dirname $0`/../agentspark --unum 2 --paramsfile `dirname $0`/../paramfiles/defaultParams.txt --paramsfile $1 --experimentout $2 --optimize walkFrontAgent --port $SPARK_AGENTPORT & 
# possible Agents:
# walkFrontAgent
# turnLeftAgent
# walkSideAgent
# walkTargetAgent
# walkFrontStopAgent
AGENTPID=$!
sleep 3
perl `dirname $0`/beamball-and-kickoff.pl -6 -9 0 # move the ball out of the way and force a kickoff to start 


sleep 25
echo "Killing Simulator"
kill -s 2 $PID
echo "Killing Agent"
kill -s 2 $AGENTPID

sleep 2
echo "Finished"

#rm /tmp/simspark-condor
