#ifndef _OPTIMIZATION_BEHAVIORS_H
#define _OPTIMIZATION_BEHAVIORS_H

#include "naobehavior.h"

class OptimizationBehaviorWalkFront : public NaoBehavior {

    string outputFile;

  public:

    OptimizationBehaviorWalkFront(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

class OptimizationBehaviorWalkBack : public NaoBehavior {

    string outputFile;

  public:

    OptimizationBehaviorWalkBack(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

class OptimizationBehaviorTurnLeft : public NaoBehavior {

    string outputFile;

    double diff( double currentAngle, double lastAngle );

  public:

    OptimizationBehaviorTurnLeft(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

class OptimizationBehaviorWalkSideway : public NaoBehavior {

    string outputFile;

  public:

    OptimizationBehaviorWalkSideway(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

class OptimizationBehaviorWalkTarget : public NaoBehavior {

    string outputFile;

  public:

    OptimizationBehaviorWalkTarget(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

class OptimizationBehaviorWalkFrontStop : public NaoBehavior {

    string outputFile;
    VecPosition startMe;

  public:

    OptimizationBehaviorWalkFrontStop(const std::string teamName, int uNum, const map<string, string>& namedParams_, const string& outputFile_);

    virtual void beam( double& beamX, double& beamY, double& beamAngle );
    virtual SkillType selectSkill();
    virtual void updateFitness();

};

#endif
