#include "naobehavior.h"

void NaoBehavior::walk_front(){
  double L3target1 = -21.789616812759462; //-25.059026848162265; //-20.084870235024262;
  double L4target1 = -17.245294695744136; //-16.223562509303022; //-19.615444221813693;
  double L5target1 = 45.26583182557041; //47.89758946598243; //46.40370796572707;
  double L3target2 = 64.31559461984287; //69.14137119180538; //55.49811773399807;
  double L5target2 = -50.12785450705887; //-54.8472043321292;// -50.8111266889541;

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_LL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_LL5, L5target1);
  }
  else if(skillState == 4){
        
    bodyModel->increaseTargetAngle(EFF_LL3, L3target2);
    bodyModel->increaseTargetAngle(EFF_LL5, L5target2);
  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_RL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_RL5, L5target1);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, L3target2);
    bodyModel->increaseTargetAngle(EFF_RL5, L5target2);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_back(){

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 30.0);
  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 30.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_left(){
  double L3target1 = 1.2011200551573857; //15.0
  double L4target1 = -25.780215483764817; //-30.0
  double L5target1 = 19.068899019010072; //15.0
  double L2target2 = 27.2557032064808; //11.0
  double L6target2 = -9.076187708482593; //-11.0
  double L1target2 = 1.8053944290732615; //-3.5
  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_LL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_LL5, L5target1);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL2, L2target2);
    bodyModel->increaseTargetAngle(EFF_LL6, L6target2);

    bodyModel->increaseTargetAngle(EFF_LL1, L1target2);
  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_RL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_RL5, L5target1);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL2, L2target2);
    bodyModel->increaseTargetAngle(EFF_RL6, L6target2);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_right(){
  double L3target1 = 1.2011200551573857; //15.0
  double L4target1 = -25.780215483764817; //-30.0
  double L5target1 = 19.068899019010072; //15.0
  double L2target2 = -27.2557032064808; //-11.0
  double L6target2 = 9.076187708482593; //11.0
  double L1target2 = 1.8053944290732615; //-3.5

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_LL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_LL5, L5target1);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL2, L2target2);
    bodyModel->increaseTargetAngle(EFF_LL6, L6target2);

  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, L3target1);
    bodyModel->increaseTargetAngle(EFF_RL4, L4target1);
    bodyModel->increaseTargetAngle(EFF_RL5, L5target1);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL2, L2target2);
    bodyModel->increaseTargetAngle(EFF_RL6, L6target2);

    bodyModel->increaseTargetAngle(EFF_RL1, L1target2);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::turn_left(){

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 20.0);

  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, -20.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::turn_right(){

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, -20.0);
  }
  else if(skillState == 10){
      
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 20.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::kick_front(){
  double KICK_WAIT_TIMEOUT = 3;

  if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 1; 
    }
  }
  else if(skillState < 25){
    skillState++;
  }
  else if(skillState == 25){
    
    if(kickLeg == LEG_RIGHT){
      bodyModel->setTargetAngle(EFF_LL2, -10.0);
      bodyModel->setTargetAngle(EFF_LL6, 10.0);
    }
    else{
      bodyModel->setTargetAngle(EFF_RL2, 10.0);
      bodyModel->setTargetAngle(EFF_RL6, -10.0);
    }
    
    bodyModel->increaseTargetAngle(EFF_LL3, 10.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 10.0);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 10.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 10.0);
    
    skillState = 26; 
  }
  else if(skillState == 26){
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 27; 
    }
  }
  else if(skillState == 27){
    
    VecPosition temp = ball - (kickDirection * 0.18);
    temp.setZ(0.05);
    VecPosition localTarget = worldModel->g2l(temp);
    double angle = 0;
    
    if(kickLeg == LEG_RIGHT){
      
      if(!(bodyModel->reachOutLeg(LEG_RIGHT, localTarget, angle))){
	
	//localTarget = VecPosition(-0.02, -0.08, -0.29);
	//angle = 0;
	//bodyModel->reachOutLeg(LEG_RIGHT, localTarget, angle);
	
	//Equivalent
	bodyModel->setTargetAngle(EFF_RL1, 0);
	bodyModel->setTargetAngle(EFF_RL2, -10.0);
	bodyModel->setTargetAngle(EFF_RL3, 25.0);
	bodyModel->setTargetAngle(EFF_RL4, -95.0);
	bodyModel->setTargetAngle(EFF_RL5, 70.0);
	bodyModel->setTargetAngle(EFF_RL6, 10.0);
	
      }
      
      bodyModel->increaseTargetAngle(EFF_RL5, -10.0);
    }
    else{
      
      if(!(bodyModel->reachOutLeg(LEG_LEFT, localTarget, angle))){
	
	//	localTarget = VecPosition(-0.02, 0.08, -0.29);
	//	angle = 0;
	//	bodyModel->reachOutLeg(LEG_LEFT, localTarget, angle);
	
	//Equivalent
	bodyModel->setTargetAngle(EFF_LL1, 0);
	bodyModel->setTargetAngle(EFF_LL2, 10.0);
	bodyModel->setTargetAngle(EFF_LL3, 25.0);
	bodyModel->setTargetAngle(EFF_LL4, -95.0);
	bodyModel->setTargetAngle(EFF_LL5, 70.0);
	bodyModel->setTargetAngle(EFF_LL6, -10.0);
	
      }

      bodyModel->increaseTargetAngle(EFF_LL5, -10.0);
    }
    
    skillState = 28; 
  }
  else if(skillState == 28){
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 29; 
    }
  }
  else if(skillState == 29){
    
    if(kickLeg == LEG_RIGHT){
      
      if(kickType == KICK_LONG){
	bodyModel->setScale(EFF_RL3, 2.0);
	bodyModel->setTargetAngle(EFF_RL3, 100.0);
      }
      else{//kickType == KICK_SHORT
	bodyModel->setTargetAngle(EFF_RL3, 60.0);
      }


      bodyModel->setTargetAngle(EFF_RL4, 0);
      bodyModel->setTargetAngle(EFF_RL5, 0);
    }    
    else{

      if(kickType == KICK_LONG){
	bodyModel->setScale(EFF_LL3, 2.0);
	bodyModel->setTargetAngle(EFF_LL3, 100.0);
      }
      else{//kickType == KICK_SHORT
	bodyModel->setTargetAngle(EFF_LL3, 60.0);
      }

      bodyModel->setTargetAngle(EFF_LL4, 0);
      bodyModel->setTargetAngle(EFF_LL5, 0);
    }
    
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 30; 

      bodyModel->setScale(EFF_LL3, 1.0);
      bodyModel->setScale(EFF_RL3, 1.0);
    }
  }
  else if(skillState == 30){
    
    if(kickLeg == LEG_RIGHT){
      bodyModel->setTargetAngle(EFF_RL3, 40.0);
      bodyModel->setTargetAngle(EFF_RL4, -60.0);
      bodyModel->setTargetAngle(EFF_RL5, 20.0);
    }    
    else{
      bodyModel->setTargetAngle(EFF_LL3, 40.0);
      bodyModel->setTargetAngle(EFF_LL4, -60.0);
      bodyModel->setTargetAngle(EFF_LL5, 20.0);
    } 
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 31; 
    }
  }
  else if(skillState == 31){
    
    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    if (kickTimeWait < 0) {
      kickTimeWait = worldModel->getTime();
    }
    if(bodyModel->targetsReached() || 
       (kickTimeWait >= 0 && worldModel->getTime()-kickTimeWait > KICK_WAIT_TIMEOUT)){
      kickTimeWait = -1;
      skillState = 32; 
    }
  }
  else if(skillState < 50){
    skillState++;
  }
  else if(skillState == 50){
    skillState = 0;
  }
  
}

void NaoBehavior::stand(){

  bodyModel->setInitialHead();
  bodyModel->setInitialArm(ARM_LEFT);
  bodyModel->setInitialArm(ARM_RIGHT);
  bodyModel->setInitialLeg(LEG_LEFT);
  bodyModel->setInitialLeg(LEG_RIGHT);
  
  skillState = (skillState + 1) % 10;
}

void NaoBehavior::find_ball_left() {
  /*if(skillState == 0){

    bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
    
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
    bodyModel->setTargetAngle(EFF_H2, -33);
    
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 20.0);

  }
  else if(skillState == 10){
      
    //bodyModel->setInitialHead();
    bodyModel->setInitialArm(ARM_LEFT);
    bodyModel->setInitialArm(ARM_RIGHT);
      
    bodyModel->setInitialLeg(LEG_LEFT);
    bodyModel->setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
    //bodyModel->setTargetAngle(EFF_H2, 0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, -20.0);
    }
  
  if (skillState < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
  }

  skillState = (skillState + 1) % 20;*/
  turn_left();

  /*if (skillState-1 == 0) {
    bodyModel->setTargetAngle(EFF_H2, -33);
  } else if (skillState-1 == 10) {
    bodyModel->setTargetAngle(EFF_H2, 3);
  }
  if (skillState-1 < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
    }*/
  
}

void NaoBehavior::find_ball_right() {
  turn_right();

  /*
  if (skillState-1 == 0) {
    bodyModel->setTargetAngle(EFF_H2, -33);
  } else if (skillState-1 == 10) {
    bodyModel->setTargetAngle(EFF_H2, 3);
  }
  if (skillState-1 < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
  }
  */
}
