#include "naobehavior.h"

SkillType NaoBehavior::selectSkill(){
  /*if (1) {
    return SKILL_FIND_BALL_LEFT;
  }*/
// cerr << "selectSkill()" << endl;

  /*  if(currentTurnState == TURNING_LEFT){

    double distance, angle;
    getTargetDistanceAndAngle(turnTarget, distance, angle);

    if(fabs(angle) > turnTargetAngleThreshold){
      return SKILL_TURN_LEFT;
    }

    currentTurnState = NONE;
  }

  if(currentTurnState == TURNING_RIGHT){

    double distance, angle;
    getTargetDistanceAndAngle(turnTarget, distance, angle);

    if(fabs(angle) > turnTargetAngleThreshold){
      return SKILL_TURN_RIGHT;
    }

    currentTurnState = NONE;
    }*/

  double BALL_FIND_THRESH = 5;
  //cout << "Time find = " << worldModel->getTime() - worldModel->getLastBallSightingTime() << endl;
  if (!worldModel->getWorldObject(WO_BALL)->validPosition) {// && 
    //worldModel->getTime() - worldModel->getLastBallSightingTime() > BALL_FIND_THRESH) {
    return findBall();
  } else {
    currentTurnState = NONE;
  }
  
  if(closestTeammateToBall){
    return driveBallToGoal();
  }

  //Hack
  if(worldModel->getUNum() == 1){
    return goalie();
  }
  else{
    /*
    VecPosition targetPoint = ball;

    if(targetPoint.getX() < 0){
      targetPoint.setX(targetPoint.getX() - 1.0);
    }

    if(me.getDistanceTo(ball) < 1.75){
      
      for(int i = WO_TEAMMATE1; i <= WO_TEAMMATE11; ++i){
        // skip myself
        if ( i == worldModel->getUNum() )
          continue;

        WorldObject* teammate = worldModel->getWorldObject( i );
		// TODO: Should the seen check be here?
        if ( teammate->currentlySeen ) {
          if((teammate->pos.getDistanceTo(ball) < 0.75) && !(targetPoint.getX() < 0)){
            return SKILL_STAND;
          }
        }
      }
    }
    */
    return goToSpace();
  }   
}

SkillType NaoBehavior::goToSpace(){
  //cout << "Go to space" << endl;
  VecPosition ballOffset;
  switch(worldModel->getUNum()){
  case 2:
    ballOffset = VecPosition(-2,.25,0);
    break;
  case 3:
    ballOffset = VecPosition(3,2,0);
    break;
  case 4:
    ballOffset = VecPosition(3,-2,0);
    break;
  case 5:
    ballOffset = VecPosition(-4,1,0);
    break;
  case 6:
    ballOffset = VecPosition(-4,-1,0);
    break;
  default:
    return watchBall();
  }

  VecPosition target = ball + ballOffset;
  if (target.getX() > HALF_FIELD_X-.5) {
    target.setX(HALF_FIELD_X-.5);
  } else if (target.getX() < -HALF_FIELD_X+.5) {
    target.setX(-HALF_FIELD_X+.5);
  }
  if (target.getY() > HALF_FIELD_Y-.5) {
    target.setY(HALF_FIELD_Y)-.5;
  } else if (target.getY() < -HALF_FIELD_Y+.5) {
    target.setY(-HALF_FIELD_Y+.5);
  }

  // Squeeze to the center when we're near the goals
  if (target.getX() > HALF_FIELD_X-2 || target.getX() < -HALF_FIELD_X+2) {
    target.setY(target.getY()/2.0);
  }

  //cerr << "team = " << worldModel->getSide() << ", num = " << worldModel->getUNum() <<  ", space target = " << target << endl;

  double SPACE_THRESH = .75;
  if (me.getDistanceTo(target) > SPACE_THRESH) {
    return goToTarget(target);
  }
  
  
  return watchBall();
}

SkillType NaoBehavior::watchBall(){
  //cout << "watch ball" << endl;
  const double BALL_CENTER_THRESH = 10;
  VecPosition localBall = worldModel->g2l(ball);
  AngDeg localBallAngle = atan2Deg(localBall.getY(), localBall.getX());
  if (localBallAngle > BALL_CENTER_THRESH) {
    return SKILL_TURN_LEFT;
  } else if (localBallAngle < -BALL_CENTER_THRESH) {
    return SKILL_TURN_RIGHT;
  }
  return SKILL_STAND;
}

SkillType NaoBehavior::findBall(){
//  cerr << "findBall()" << endl;
  //cout << "Looking for ball" << endl;
  
  if (currentTurnState == TURNING_LEFT_FOR_BALL) {
    return SKILL_FIND_BALL_LEFT;
  } else if (currentTurnState == TURNING_RIGHT_FOR_BALL) {
    return SKILL_FIND_BALL_RIGHT;
  } 

  if (worldModel->g2l(ball).getY() > 0) {
    currentTurnState = TURNING_LEFT_FOR_BALL;
    return SKILL_FIND_BALL_LEFT;
  } else { 
    currentTurnState = TURNING_RIGHT_FOR_BALL;
    return SKILL_FIND_BALL_RIGHT;
  }
}

//Remember -- if the ball moves, things must be reset.
SkillType NaoBehavior::driveBallToGoal(){
  //cout << "Drive ball to goal " << endl;
  double angleThreshold;
  double lateralThreshold;
  SkillType tempSkill;

  bool toAvoid;


  if(me.getDistanceTo(ball) > 0.6){
    positioning = false;
  }

  if(me.getDistanceTo(ball) > 0.4 && !positioning){
    VecPosition goalPostMid = (worldModel->getOppLeftGoalPost() + worldModel->getOppRightGoalPost()) * 0.5;
    goalPostMid.setZ(0);
    VecPosition direction = (goalPostMid - ball).normalize();

    VecPosition target = ball - (VecPosition(direction) * 0.08);
    target.setZ(0);
    return goToTarget(target);
  }
  else{

    //    if(!positioning){

    positioning = true;

    //Fix kickType and kickDir

    //      VecPosition goalPostMid = (worldModel->getOppLeftGoalPost() + worldModel->getOppRightGoalPost()) * 0.5;
    //      goalPostMid.setZ(0);
    //      kickDirection = (goalPostMid - ball).normalize();

    VecPosition targetLeft = worldModel->getOppLeftGoalPost() * 0.75 + worldModel->getOppRightGoalPost() * 0.25;
    targetLeft.setZ(0);

    VecPosition targetRight = worldModel->getOppLeftGoalPost() * 0.25 + worldModel->getOppRightGoalPost() * 0.75;
    targetRight.setZ(0);

    toAvoid = false;
    for(int i = WO_OPPONENT1; i <= WO_OPPONENT11; ++i){

      WorldObject* opponentObj = worldModel->getWorldObject( i );
      // TODO: should this check for seen be here?
      if ( opponentObj->validPosition ) { 
        VecPosition opp = opponentObj->pos;
        opp.setZ(0);

        double oppAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(opp - ball, kickDirection);
        double oppDistance = opp.getDistanceTo(ball);

        if(oppDistance < 0.9){
          toAvoid = true;
          //	  cout << "Avoiding\n";
        }
      }
    }

    if(ball.getY() >= 0){
      kickDirection = (targetLeft - ball).normalize();
    }
    else{
      kickDirection = (targetRight - ball).normalize();
    }

    bool kickStraight = (ball.getX() > HALF_FIELD_X - 1.5) && (fabs(ball.getY()) < 0.9 * HALF_GOAL_Y);
    if(kickStraight){
      //If near goal, kick straight
      kickDirection = VecPosition(1.0, 0, 0);
    }

    VecPosition target = ball - (VecPosition(kickDirection) * 0.08);
    target.setZ(0);

    //      cout << "My Goal Distance: " << worldModel->distanceToMyGoal(ball) << "\n";
    //      cout << "Opp Goal Distance: " << worldModel->distanceToOppGoal(ball) << "\n";

    //    }

    //Simplify toAvoid

    if(toAvoid){
      kickType = KICK_DRIBBLE;//KICK_LONG;
    }
    else if(worldModel->distanceToOppGoal(ball) < 2.8){
      kickType = KICK_LONG;
    }
    else if(worldModel->distanceToMyGoal(ball) < 3.5){
      kickType = KICK_DRIBBLE;//KICK_LONG;
    }
    else{
      kickType = KICK_DRIBBLE;
    }

    //cout << "kickType = " << kickType << endl;
      
    
    if(kickType == KICK_LONG){
      angleThreshold = 10.0;
      lateralThreshold = 0.035; // Changed back to the orig threshold
    }
    else if(kickType == KICK_SHORT){
      angleThreshold = 10.0;
      lateralThreshold = 0.035; // Changed back to the orig threshold
    }
    else{// if(kickType == KICK_DRIBBLE){
      angleThreshold = 15.0;
      lateralThreshold = 0.055;
    }

    // TODO: HACK Try and prevent thrashing in front of the opponent's goal
    if (kickStraight) {
      kickType = KICK_DRIBBLE;
      angleThreshold = 35.0;
    }

    //    bool canKick = positioningToKick(direction, angleThreshold, lateralThreshold, target, tempSkill);
    bool canKick = positioningToKick(kickDirection, angleThreshold, lateralThreshold, target, tempSkill);

    if(canKick){

      if(kickType == KICK_LONG){

        return SKILL_KICK_FRONT;
      }
      else if(kickType == KICK_SHORT){

        return SKILL_KICK_FRONT;
      }
      else{// if(kickType == KICK_DRIBBLE){

        return SKILL_WALK_FRONT;
      }
      }

      return tempSkill;
    }

}

//Assumes target = z-0. Get to within 0.5m of target. Needs further tuning
SkillType NaoBehavior::goToTarget(const VecPosition &target){
//  cerr << "goToTarget()\n";

  double distance, angle;
  getTargetDistanceAndAngle(target, distance, angle);

//  cerr << "D, A: " << distance << ", " << angle << "\n";
  if(distance > 5.5){

    if(angle <= -14.0){
      setTurn(DIR_RIGHT, target, 10.0); return SKILL_TURN_RIGHT;
    }
    else if(angle >= 14.0){
      setTurn(DIR_LEFT, target, 10.0); return SKILL_TURN_LEFT;
    }
  }
  else if(distance > 3.0){

    if(angle <= -16.0){
      setTurn(DIR_RIGHT, target, 11.0); return SKILL_TURN_RIGHT;
    }
    else if(angle >= 16.0){
      setTurn(DIR_LEFT, target, 11.0); return SKILL_TURN_LEFT;
    }
  }
  else if(distance > 0.25){

    if(angle <= -18.0){
      setTurn(DIR_RIGHT, target, 13.0); return SKILL_TURN_RIGHT;
    }
    else if(angle >= 18.0){
      setTurn(DIR_LEFT, target, 13.0); return SKILL_TURN_LEFT;
    }
  }

  return SKILL_WALK_FRONT;
}

void NaoBehavior::refresh(){
//  cerr << "refresh()" << endl;

  myXDirection = worldModel->l2g(VecPosition(1.0, 0, 0)) - worldModel->l2g(VecPosition(0, 0, 0));
  myXDirection.setZ(0);
  myXDirection.normalize();
  
  myYDirection = worldModel->l2g(VecPosition(0, 1.0, 0)) - worldModel->l2g(VecPosition(0, 0, 0));
  myYDirection.setZ(0);
  myYDirection.normalize();

  //Anomalous
  myZDirection = worldModel->l2g(VecPosition(0, 0, 1.0)) - worldModel->l2g(VecPosition(0, 0, 0));
  //  myZDirection.setZ(0);
  myZDirection.normalize();

  me = worldModel->getMyPosition(); // ->l2g(VecPosition(0, 0, 0)); // <- had consistency problems
  me.setZ(0);

  //if (worldModel->getWorldObject(WO_BALL)->currentlySeen) {
    ball = worldModel->getBall();
    ball.setZ(0);
    //cout << "Ball = " << ball << endl;
    //}

  double disBall = me.getDistanceTo(ball);
  //cout << "pos ball = " << worldModel->getBall() << ", ang = " << atan2Deg(ball.getY(), ball.getX()) << endl;

  VecPosition goalCentre = (worldModel->getMyLeftGoalPost() + worldModel->getMyRightGoalPost()) * 0.5;
  goalCentre.setZ(0);
  double disGoal = me.getDistanceTo(goalCentre);

  closestTeammateToBall = true;
  closestTeammateToGoal = true;

  for(int i = WO_TEAMMATE1; i <= WO_TEAMMATE11; ++i){

    // skip myself
    if ( i == worldModel->getUNum() )
      continue;

    WorldObject* teammate = worldModel->getWorldObject( i );
	//TODO: should the check for seen be here???
    if (teammate->validPosition) {
      VecPosition temp = teammate->pos;
      temp.setZ(0);
      //cout << "Teamate " << i << " pos = " << temp  << "dist = " <<  temp.getDistanceTo(ball) << endl;
      const double CLOSEST_ERROR = .45;
      const double DIR_CLOSEST_BALL_ADJ = .5;
      double meDisBall = me.getX() < ball.getX() ? disBall : disBall + DIR_CLOSEST_BALL_ADJ;
      double teammateDisBall = temp.getX() < ball.getX() ? temp.getDistanceTo(ball) : temp.getDistanceTo(ball) + DIR_CLOSEST_BALL_ADJ;
      if(temp.getDistanceTo(ball) < meDisBall-CLOSEST_ERROR){
        closestTeammateToBall = false;
      }

      if(temp.getDistanceTo(goalCentre) < disGoal){
        closestTeammateToGoal = false;
      }
    }
  }

  //  if(closestTeammateToBall && (worldModel->getSide() == SIDE_LEFT)){
  //    cout << "UNum " << worldModel->getUNum() << " closest to ball " << disBall << "\n";
  // }

    //    if(closestTeammateToGoal){
    //    cout << "UNum " << worldModel->getUNum() << " closest to goal.\n";
    //    }


}

//Assumes target it z-0.
void NaoBehavior::getTargetDistanceAndAngle(const VecPosition &target, double &distance, double &angle){
//  cerr << "getTargetDistanceAndAngle()" << endl;

  VecPosition targetDirection = VecPosition(target) - me;
  targetDirection.setZ(0);

  // distance
  distance = targetDirection.getMagnitude();

  // angle
  targetDirection.normalize();
// TODO: Daniel changed because think it's not correct (z should be 0), so moved it up ^
//  distance = (VecPosition(target) - me).getMagnitude();
  angle = VecPosition(0, 0, 0).getAngleBetweenPoints(myXDirection, targetDirection);
  if(myYDirection.dotProduct(targetDirection) < 0){
    angle = -angle;
  }
}

void NaoBehavior::resetSkills(){
//  cerr << "resetSkills()" << endl;

  skill = SKILL_STAND;
  skillState = 0;

  currentTurnState = NONE;
  turnTarget = VecPosition(0, 0, 0);
  turnTargetAngleThreshold = 10.0;

  kickLeg = LEG_LEFT;
  kickDirection = VecPosition(1.0, 0, 0);

  positioning = false;

  bodyModel->setScale(EFF_LL3, 1.0);
  bodyModel->setScale(EFF_RL3, 1.0);

  kickType = KICK_LONG;

  closestTeammateToBall = false;
  closestTeammateToGoal = false;
  worldModel->setLastSkill(skill);
}

void NaoBehavior::setTurn(const int &direction, const VecPosition &target, const double &angleThreshold){
//  cerr << "setTurn()" << endl;
  turnTarget = target;
  turnTargetAngleThreshold = angleThreshold;

  if(direction == DIR_LEFT){
    currentTurnState = TURNING_LEFT;
  }
  else{//direction == DIR_RIGHT
    currentTurnState = TURNING_RIGHT;
  }
}


//Assumes within Xm of ball.
bool NaoBehavior::positioningToKick(const VecPosition &direction, const double &angleThreshold, const double &lateralThreshold, const VecPosition &targetPos, SkillType &skillToTake){
//  cerr << "positioningToKick()" << endl;
  VecPosition target = VecPosition(targetPos);
  target.setZ(0);

  VecPosition leftCG, leftXAxis, leftYAxis, leftZAxis;
  bodyModel->getFootGlobalCGAndAxes(LEG_LEFT, leftCG, leftXAxis, leftYAxis, leftZAxis);
//  // TODO: Daniel debug remove, good only for estimated pose check
//  cerr << "Daniel leftCG before " << leftCG << endl;
//  VecPosition myPos = worldModel->getMyPosition();
//  VecPosition newPos = myPos;
//  newPos.setZ(0.53);
//  worldModel->setMyPosition( newPos );
//  bodyModel->getFootGlobalCGAndAxes(LEG_LEFT, leftCG, leftXAxis, leftYAxis, leftZAxis);
//  cerr << "Daniel leftCG after " << leftCG << endl;
//  worldModel->setMyPosition( myPos );
//  // end remove

  double leftAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(leftXAxis, direction);

  VecPosition rightCG, rightXAxis, rightYAxis, rightZAxis;
  bodyModel->getFootGlobalCGAndAxes(LEG_RIGHT, rightCG, rightXAxis, rightYAxis, rightZAxis);

  double rightAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(rightXAxis, direction);

  VecPosition lateralDirection = VecPosition(0, 0, 1.0).crossProduct(direction);

  const double distanceBehindBall = (ball - me).dotProduct(direction);
  const double lateralDistanceFromDirection = (ball - me).dotProduct( lateralDirection );
  // TODO: Daniel: thinks that older value of 13 cm causes to thrashing very close to the ball
  // so added one more rectangle of "legal" area to stand behind the ball in the second condition
  bool behindBall = distanceBehindBall >  0.13 ; // || ( distanceBehindBall > 0.08 && abs( lateralDistanceFromDirection < 0.10 ) );
//  cerr << "Behind Ball: " << behindBall << " ball " << ball << " me " << me << " direction " << direction << " value= " << (ball - me).dotProduct(direction) << endl;

  if(behindBall){

    double directionAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(myXDirection, direction);
    if(myYDirection.dotProduct(direction) < 0){
      directionAngle = -directionAngle;
    }

    if(directionAngle > angleThreshold){
      skillToTake = SKILL_TURN_LEFT;
      return false;
    }
    else if(directionAngle < -angleThreshold){
      skillToTake = SKILL_TURN_RIGHT;
      return false;
    }

    // threshold below which we can kick 
    const double thresholdDistBehind = 0.17; //0.16; // 0.13; TODO: changed so won't be too close to ball?


    // next few lines: cumbersome way to initialize the closest leg center of gravity
    VecPosition legCG;
    int candidateKickLeg = -1;
//    if( leftDistance < rightDistance ) {
    if( (target - me).dotProduct( lateralDirection ) > 0 ) {
      legCG = worldModel->l2g(VecPosition(0,.05,0));
      candidateKickLeg = LEG_LEFT;
    } else {
      legCG = worldModel->l2g(VecPosition(0,-.05,0));
      candidateKickLeg = LEG_RIGHT;
    }

    //cout << "DANIEL DEBUG: check whether to kick. target=" << target << " legCG=" << legCG << endl;
    if((target - legCG).dotProduct(lateralDirection) > lateralThreshold){
      skillToTake = SKILL_WALK_LEFT;
      return false;
    } else if((target - legCG).dotProduct(lateralDirection) < -lateralThreshold){
      skillToTake = SKILL_WALK_RIGHT;
      return false;
    } else if((target - me).dotProduct(direction) > thresholdDistBehind){ // too far
      skillToTake = SKILL_WALK_FRONT;
      return false;
    } else {
      //cout << "DANIEL DEBUG: KICKING. target=" << target << " legCG=" << legCG << endl; 
      kickLeg = candidateKickLeg;
      return true;
    }


//    if(leftDistance < rightDistance){
//
//      if((target - leftCG).dotProduct(lateralDirection) > lateralThreshold){
//        skillToTake = SKILL_WALK_LEFT;
//        return false;
//      }
//      else if((target - leftCG).dotProduct(lateralDirection) < -lateralThreshold){
//        skillToTake = SKILL_WALK_RIGHT;
//        return false;
//      }
//      else if((target - leftCG).dotProduct(direction) > thresholdDistBehind){ // too far
//        skillToTake = SKILL_WALK_FRONT;
//        return false;
//      }
//      else{
//        kickLeg = LEG_LEFT;
//        return true;
//      }
//
//    }
//    else{
//
//      if((target - rightCG).dotProduct(lateralDirection) > lateralThreshold){
//        skillToTake = SKILL_WALK_LEFT;
//        return false;
//      }
//      else if((target - rightCG).dotProduct(lateralDirection) < -lateralThreshold){
//        skillToTake = SKILL_WALK_RIGHT;
//        return false;
//      }
//      else if((target - rightCG).dotProduct(direction) > thresholdDistBehind){ // too far
//        skillToTake = SKILL_WALK_FRONT;
//        return false;
//      }
//      else{
//        kickLeg = LEG_RIGHT;
//        return true;
//      }
//    }
  }
  else{ //In front of ball

    double lateralDirectionAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(myXDirection, VecPosition(lateralDirection));
    if(myYDirection.dotProduct(VecPosition(lateralDirection)) < 0){
      lateralDirectionAngle = -lateralDirectionAngle;
    }

    if((me - ball).dotProduct(lateralDirection) > 0){

      if(lateralDirectionAngle >= 0 && lateralDirectionAngle <= 160.0){
        skillToTake = SKILL_TURN_RIGHT;
        return false;
      }
      else if(lateralDirectionAngle < 0 && lateralDirectionAngle > -160.0){
        skillToTake = SKILL_TURN_LEFT;
        return false;
      }

      if((me - ball).dotProduct(lateralDirection) < 0.13){
        skillToTake = SKILL_WALK_BACK;
        return false;
      }
      else{
        skillToTake = SKILL_WALK_RIGHT;
        return false;
      }
    }
    else{

      if(lateralDirectionAngle >= 20.0 && lateralDirectionAngle <= 180.0){
        skillToTake = SKILL_TURN_LEFT;
        return false;
      }
      else if(lateralDirectionAngle < -20.0 && lateralDirectionAngle > -180.0){
        skillToTake = SKILL_TURN_RIGHT;
        return false;
      }

      if((me - ball).dotProduct(lateralDirection) > -0.13){
        skillToTake = SKILL_WALK_BACK;
        return false;
      }
      else{
        skillToTake = SKILL_WALK_LEFT;
        return false;
      }
    }

  }

  skillToTake = SKILL_WALK_FRONT;
  return false;
}

bool NaoBehavior::improperPlayMode(){
//  cerr << "improperPlayMode()" << endl;

  int pm = worldModel->getPlayMode();

  if(pm == PM_BEFORE_KICK_OFF){
    return true;
  }
  else if(pm == PM_GAME_OVER){
    return true;
  }
  else if(pm == PM_GOAL_LEFT){
    return true;
  }
  else if(pm == PM_GOAL_RIGHT){
    return true;
  }

  if(worldModel->getSide() == SIDE_LEFT){

    if(pm == PM_KICK_OFF_RIGHT){
      return true;
    }
    else if(pm == PM_KICK_IN_RIGHT){
      return true;
    }
    else if(pm == PM_CORNER_KICK_RIGHT){
      return true;
    }
    else if(pm == PM_GOAL_KICK_RIGHT){
      return true;
    }
    else if(pm == PM_OFFSIDE_LEFT){
      return true;
    }
    else if(pm == PM_FREE_KICK_RIGHT){
      return true;
    }
  }
  else if(worldModel->getSide() == SIDE_RIGHT){

    if(pm == PM_KICK_OFF_LEFT){
      return true;
    }
    else if(pm == PM_KICK_IN_LEFT){
      return true;
    }
    else if(pm == PM_CORNER_KICK_LEFT){
      return true;
    }
    else if(pm == PM_GOAL_KICK_LEFT){
      return true;
    }
    else if(pm == PM_OFFSIDE_RIGHT){
      return true;
    }
    else if(pm == PM_FREE_KICK_LEFT){
      return true;
    }
  }

  return false;
}

SkillType NaoBehavior::goalie(){
//  cerr << "goalie()" << endl;

  //  cout << "Ball: " << ball << "\n";
  //  cout << "Me: " << me << "\n";

  double forwardDirectionAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(myXDirection, VecPosition(1.0, 0, 0));
  if(myYDirection.dotProduct(VecPosition(1.0, 0, 0)) < 0){
    forwardDirectionAngle = -forwardDirectionAngle;
  }

  if(forwardDirectionAngle > 20.0){
    setTurn(DIR_LEFT, VecPosition(0, me.getY(), 0), 5.0);
    return SKILL_TURN_LEFT;
  }
  else if(forwardDirectionAngle < -20.0){
    setTurn(DIR_RIGHT, VecPosition(0, me.getY(), 0), 5.0);
    return SKILL_TURN_RIGHT;
  }

  if(me.getX() < -HALF_FIELD_X + .05){
    return SKILL_WALK_FRONT;
  }
  else if(me.getX() > -HALF_FIELD_X + .3){
    return SKILL_WALK_BACK;
  }
  
  if(ball.getY() > 0.3){

    if(me.getY() > 0.3){
      return SKILL_WALK_RIGHT;
    }
    else if(me.getY() < 0.2){
      return SKILL_WALK_LEFT;
    }
  }
  else if(ball.getY() < -0.3){

    if(me.getY() < -0.3){
      return SKILL_WALK_LEFT;
    }
    else if(me.getY() > -0.2){
      return SKILL_WALK_RIGHT;
    }
  }
  else{
    
    if(me.getY() < -0.075){
      return SKILL_WALK_LEFT;
    }
    else if(me.getY() > 0.075){
      return SKILL_WALK_RIGHT;
    }
  }

  return SKILL_STAND;

}
