#include "naobehavior.h"

bool NaoBehavior::checkingFall(){
  static int feetUngroundedCount = 0;
  
  if (bodyModel->getFRPForce(LEG_LEFT).getZ() <= 0 && bodyModel->getFRPForce(LEG_RIGHT).getZ() <= 0) {
    feetUngroundedCount++;
  } else {
    feetUngroundedCount = 0;
  }


  if(fallenLeft){
    //    cout << "FALLEN LEFT\n";
    riseLeft();
  }
  else if(fallenRight){
    //    cout << "FALLEN RIGHT\n";
    riseRight();
  }
  else if(fallenUpRollLeft){
    //    cout << "FALLEN UP\n";
    riseUpLeft();
  }
  else if(fallenUpRollRight){
    //    cout << "FALLEN UP\n";
    riseUpRight();
  }
  else if(fallenDown){
    //    cout << "FALLEN DOWN\n";
    riseDown();
  }

  if(fallenLeft || fallenRight || fallenUpRollLeft || fallenUpRollRight || fallenDown){
    return true;
  }

  double fallAngle = bodyModel->getFallAngle();
  //cout << "fallAngle = " << fallAngle << endl;
 // cout << "FPRZ_left = " << bodyModel->getFRPForce(LEG_LEFT).getZ() << ", FPRZ_right = " << bodyModel->getFRPForce(LEG_RIGHT).getZ() << endl;
  if((fallAngle < 20.0 && bodyModel->getGyroRates().getMagnitude() < 250 & feetUngroundedCount < 5) && (fallState == 0)){
    return false;
  }

  //  cout << "Fall Angle: " << fallAngle << ", s: " << worldModel->getCycle() << ", FS: " << fallState << "\n";

  //The real thing -- we have to rise.

  if(fallState == 0){

    setInitialHead();

    bodyModel->setTargetAngle(EFF_LA1, 90.0);
    bodyModel->setTargetAngle(EFF_LA2, 0);
    bodyModel->setTargetAngle(EFF_LA3, 0);
    bodyModel->setTargetAngle(EFF_LA4, 0);

    bodyModel->setTargetAngle(EFF_RA1, 90.0);
    bodyModel->setTargetAngle(EFF_RA2, 0);
    bodyModel->setTargetAngle(EFF_RA3, 0);
    bodyModel->setTargetAngle(EFF_RA4, 0);

    bodyModel->setTargetAngle(EFF_LL1, 0);
    bodyModel->setTargetAngle(EFF_LL2, 0);
    bodyModel->setTargetAngle(EFF_LL3, 90.0);
    bodyModel->setTargetAngle(EFF_LL4, 0);
    bodyModel->setTargetAngle(EFF_LL5, -20.0);
    bodyModel->setTargetAngle(EFF_LL6, 0);

    bodyModel->setTargetAngle(EFF_RL1, 0);
    bodyModel->setTargetAngle(EFF_RL2, 0);
    bodyModel->setTargetAngle(EFF_RL3, 90.0);
    bodyModel->setTargetAngle(EFF_RL4, 0);
    bodyModel->setTargetAngle(EFF_RL5, -20.0);
    bodyModel->setTargetAngle(EFF_RL6, 0);
   
    //    if(bodyModel->targetsReached()){
      fallState = 1;
      //    }

    return true;
  }
  else if(fallState < 120){
    fallState++;
    return true;
  }
  else if(fallState == 120){

    //See whether survived, or in which way fallen
    VecPosition zAxis = VecPosition(0, 0, 1.0);
    VecPosition bodyXAxis = (worldModel->l2g(VecPosition(1.0, 0, 0)) - worldModel->l2g(VecPosition(0, 0, 0))).normalize();

    double faceAngle = VecPosition(0, 0, 0).getAngleBetweenPoints(bodyXAxis, zAxis);
    
    VecPosition leftFootCG = worldModel->l2g(bodyModel->getFootCG(LEG_LEFT));
    VecPosition rightFootCG = worldModel->l2g(bodyModel->getFootCG(LEG_RIGHT));

    //fallenLeft = (rightFootCG.getZ() > leftFootCG.getZ() + 0.1);

    //fallenRight = (leftFootCG.getZ() > rightFootCG.getZ() + 0.1);

    //fallenUp = (faceAngle < 20.0) && (leftFootCG.getZ() > 0.2) && (rightFootCG.getZ() > 0.2);
    //fallenUp = fallenUp || ((faceAngle > 70.0) && (faceAngle < 110.0) && (leftFootCG.getZ() < 0.1) && (rightFootCG.getZ() < 0.1));

    //fallenDown = (leftFootCG.getZ() < 0.1) && (rightFootCG.getZ() < 0.1) && (fallAngle > 100.0);

    bool fallen = feetUngroundedCount >= 5;
    switch(rand()%3) {
    case 0:
      fallenUpRollLeft = fallen;
      break;
    case 1:
      fallenUpRollRight = fallen;
      break;
    default:
      fallenDown = fallen;
    } 


    if(fallenLeft) {
      fallState = 0;
      riseLeft();
      return true;
    }
    else if(fallenRight){
      fallState = 0;
      riseRight();
      return true;
    }
    else if(fallenDown){
      fallState = 0;
      riseDown();
      return true;
    }
    else if(fallenUpRollLeft){
      fallState = 0;
      riseUpLeft();
      return true;
    }
    else if(fallenUpRollRight){
      fallState = 0;
      riseUpRight();
      return true;
    }
    else{
      fallState = 121;
      return true;
    }
  }
  else if(fallState < 130){
    fallState++;
    return true;
  }
  else if(fallState == 130){

    bodyModel->setTargetAngle(EFF_LA1, -45.0);
    bodyModel->setTargetAngle(EFF_RA1, -45.0);

    bodyModel->setTargetAngle(EFF_LL3, 60.0);
    bodyModel->setTargetAngle(EFF_RL3, 60.0);

    if(bodyModel->targetsReached()){
      fallState = 131;
    }

    return true;
  }
  else if(fallState < 140){
    fallState++;
    return true;
  }
  else if(fallState == 140){

    bodyModel->setTargetAngle(EFF_LL4, -30.0);
    bodyModel->setTargetAngle(EFF_LL5, 0);

    bodyModel->setTargetAngle(EFF_RL4, -30.0);
    bodyModel->setTargetAngle(EFF_RL5, 0);

    if(bodyModel->targetsReached()){
      fallState = 141;
    }

    return true;
  }
  else if(fallState < 150){
    fallState++;
    return true;
  }
  else if(fallState == 150){

    bodyModel->setTargetAngle(EFF_LL4, -40.0);
    bodyModel->setTargetAngle(EFF_LL5, 10.0);

    bodyModel->setTargetAngle(EFF_RL4, -40.0);
    bodyModel->setTargetAngle(EFF_RL5, 10.0);

    if(bodyModel->targetsReached()){
      fallState = 151;
    }

    return true;
  }
  else if(fallState < 160){
    fallState++;
    return true;
  }
  else if(fallState == 160){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);

    if(bodyModel->targetsReached()){
      fallState = 0;
      return false;
    }

    return true;
  }

}


void NaoBehavior::riseLeft(){

  if(fallState == 0){
    
    bodyModel->setTargetAngle(EFF_LA1, 90.0);
    bodyModel->setTargetAngle(EFF_RA1, 30.0);
    
    bodyModel->setTargetAngle(EFF_LL3, -20.0);
    bodyModel->setTargetAngle(EFF_RL3, 90.0);
    
    bodyModel->setTargetAngle(EFF_LL4, -100.0);
    bodyModel->setTargetAngle(EFF_RL4, -100.0);
    
    if(bodyModel->targetsReached()){
      fallState = 1;
    }
  }
  else if(fallState < 5){
    fallState++;
  }
  else if(fallState == 5){

    bodyModel->setTargetAngle(EFF_LA1, 90.0);
    bodyModel->setTargetAngle(EFF_RA1, 90.0);

    bodyModel->setTargetAngle(EFF_LL3, -20.0);
    bodyModel->setTargetAngle(EFF_RL3, -20.0);

    bodyModel->setTargetAngle(EFF_LL4, -100.0);
    bodyModel->setTargetAngle(EFF_RL4, -100.0);

    if(bodyModel->targetsReached()){
      fallState = 0;
      fallenLeft = false;
      fallenDown = true;
    }
  }

}

void NaoBehavior::riseRight(){

  if(fallState == 0){
    
    bodyModel->setTargetAngle(EFF_LA1, 30.0);
    bodyModel->setTargetAngle(EFF_RA1, 90.0);
    
    bodyModel->setTargetAngle(EFF_LL3, 90.0);
    bodyModel->setTargetAngle(EFF_RL3, -20.0);
    
    bodyModel->setTargetAngle(EFF_LL4, -100.0);
    bodyModel->setTargetAngle(EFF_RL4, -100.0);
    
    if(bodyModel->targetsReached()){
      fallState = 1;
    }
  }
  else if(fallState < 5){
    fallState++;
  }
  else if(fallState == 5){

    bodyModel->setTargetAngle(EFF_LA1, 90.0);
    bodyModel->setTargetAngle(EFF_RA1, 90.0);

    bodyModel->setTargetAngle(EFF_LL3, -20.0);
    bodyModel->setTargetAngle(EFF_RL3, -20.0);

    bodyModel->setTargetAngle(EFF_LL4, -100.0);
    bodyModel->setTargetAngle(EFF_RL4, -100.0);

    if(bodyModel->targetsReached()){
      fallState = 0;
      fallenRight = false;
      fallenDown = true;
    }
  }
}

void NaoBehavior::riseUpLeft(){

  if(fallState == 0){

    setInitialHead();

    bodyModel->setTargetAngle(EFF_LA1, -80.0);
    bodyModel->setTargetAngle(EFF_LA2, 0);
    bodyModel->setTargetAngle(EFF_LA3, 0);
    bodyModel->setTargetAngle(EFF_LA4, 0);

    bodyModel->setTargetAngle(EFF_RA1, -80.0);
    bodyModel->setTargetAngle(EFF_RA2, 0);
    bodyModel->setTargetAngle(EFF_RA3, 0);
    bodyModel->setTargetAngle(EFF_RA4, 0);

    bodyModel->setTargetAngle(EFF_LL1, 0);
    bodyModel->setTargetAngle(EFF_LL2, 0);
    bodyModel->setTargetAngle(EFF_LL3, 0);
    bodyModel->setTargetAngle(EFF_LL4, 0);
    bodyModel->setTargetAngle(EFF_LL5, 0);
    bodyModel->setTargetAngle(EFF_LL6, 0);

    bodyModel->setTargetAngle(EFF_RL1, 0);
    bodyModel->setTargetAngle(EFF_RL2, 0);
    bodyModel->setTargetAngle(EFF_RL3, 0);
    bodyModel->setTargetAngle(EFF_RL4, 0);
    bodyModel->setTargetAngle(EFF_RL5, 0);
    bodyModel->setTargetAngle(EFF_RL6, 0);
    
    if(bodyModel->targetsReached()){
      fallState = 1;
    }
  }
  else if(fallState < 5){
    fallState++;
  }
  else if(fallState == 5){

    bodyModel->setTargetAngle(EFF_LA1, 0);
    bodyModel->setTargetAngle(EFF_RA1, -120.0);

    bodyModel->setTargetAngle(EFF_LL3, 90.0);
    bodyModel->setTargetAngle(EFF_RL3, -20.0);

    bodyModel->setTargetAngle(EFF_LL4, -90.0);
    bodyModel->setTargetAngle(EFF_RL4, -90.0);

    bodyModel->setTargetAngle(EFF_LL5, 10.0);
    bodyModel->setTargetAngle(EFF_RL5, 10.0);

    if(bodyModel->targetsReached()){
      fallState = 6;
    }
  }
  else if(fallState < 10){
    fallState++;
  }
  else if(fallState == 10){

    bodyModel->setTargetAngle(EFF_LA1, 15.0);
    bodyModel->setTargetAngle(EFF_RA1, 15.0);

    bodyModel->setTargetAngle(EFF_LL3, 70.0);
    bodyModel->setTargetAngle(EFF_RL3, 70.0);

    bodyModel->setTargetAngle(EFF_LL4, 0);
    bodyModel->setTargetAngle(EFF_RL4, 0);

    if(bodyModel->targetsReached()){
      fallState = 0;
      fallenUpRollLeft = false;
      fallenLeft = true;
    }
  }
}

void NaoBehavior::riseUpRight(){

  if(fallState == 0){

    setInitialHead();

    bodyModel->setTargetAngle(EFF_RA1, -80.0);
    bodyModel->setTargetAngle(EFF_RA2, 0);
    bodyModel->setTargetAngle(EFF_RA3, 0);
    bodyModel->setTargetAngle(EFF_RA4, 0);

    bodyModel->setTargetAngle(EFF_LA1, -80.0);
    bodyModel->setTargetAngle(EFF_LA2, 0);
    bodyModel->setTargetAngle(EFF_LA3, 0);
    bodyModel->setTargetAngle(EFF_LA4, 0);

    bodyModel->setTargetAngle(EFF_RL1, 0);
    bodyModel->setTargetAngle(EFF_RL2, 0);
    bodyModel->setTargetAngle(EFF_RL3, 0);
    bodyModel->setTargetAngle(EFF_RL4, 0);
    bodyModel->setTargetAngle(EFF_RL5, 0);
    bodyModel->setTargetAngle(EFF_RL6, 0);

    bodyModel->setTargetAngle(EFF_LL1, 0);
    bodyModel->setTargetAngle(EFF_LL2, 0);
    bodyModel->setTargetAngle(EFF_LL3, 0);
    bodyModel->setTargetAngle(EFF_LL4, 0);
    bodyModel->setTargetAngle(EFF_LL5, 0);
    bodyModel->setTargetAngle(EFF_LL6, 0);
    
    if(bodyModel->targetsReached()){
      fallState = 1;
    }
  }
  else if(fallState < 5){
    fallState++;
  }
  else if(fallState == 5){

    bodyModel->setTargetAngle(EFF_RA1, 0);
    bodyModel->setTargetAngle(EFF_LA1, -120.0);

    bodyModel->setTargetAngle(EFF_RL3, 90.0);
    bodyModel->setTargetAngle(EFF_LL3, -20.0);

    bodyModel->setTargetAngle(EFF_RL4, -90.0);
    bodyModel->setTargetAngle(EFF_LL4, -90.0);

    bodyModel->setTargetAngle(EFF_RL5, 10.0);
    bodyModel->setTargetAngle(EFF_LL5, 10.0);

    if(bodyModel->targetsReached()){
      fallState = 6;
    }
  }
  else if(fallState < 10){
    fallState++;
  }
  else if(fallState == 10){

    bodyModel->setTargetAngle(EFF_RA1, 15.0);
    bodyModel->setTargetAngle(EFF_LA1, 15.0);

    bodyModel->setTargetAngle(EFF_RL3, 70.0);
    bodyModel->setTargetAngle(EFF_LL3, 70.0);

    bodyModel->setTargetAngle(EFF_RL4, 0);
    bodyModel->setTargetAngle(EFF_LL4, 0);

    if(bodyModel->targetsReached()){
      fallState = 0;
      fallenUpRollRight = false;
      fallenRight = true;
    }
  }
}

void NaoBehavior::riseDown(){

  if(fallState == 0){
    
    bodyModel->setTargetAngle(EFF_LL3, 100.0);
    bodyModel->setTargetAngle(EFF_RL3, 100.0);
    
    bodyModel->setTargetAngle(EFF_LL4, 0);
    bodyModel->setTargetAngle(EFF_RL4, 0);
    
    bodyModel->setTargetAngle(EFF_LL5, 10.0);
    bodyModel->setTargetAngle(EFF_RL5, 10.0);

    bodyModel->setTargetAngle(EFF_LA1, 15.0);
    bodyModel->setTargetAngle(EFF_RA1, 15.0);
    
    if(bodyModel->targetsReached()){
      fallState = 1;
    }
  }
  else if(fallState < 10){
    fallState++;
  }
  else if(fallState == 20){

    bodyModel->setTargetAngle(EFF_LL1, -40.0);
    bodyModel->setTargetAngle(EFF_RL1, -40.0);
    
    if(bodyModel->targetsReached()){
      fallState = 21;
    }
  }
  else if(fallState == 21){
    
    bodyModel->setTargetAngle(EFF_LL4, -50.0);
    bodyModel->setTargetAngle(EFF_RL4, -50.0);
    
    bodyModel->setTargetAngle(EFF_LA1, 45.0);
    bodyModel->setTargetAngle(EFF_RA1, 45.0);
    
    if(bodyModel->targetsReached()){
      fallState = 22;
    }

  }
  else if(fallState < 30){
    fallState++;
  }
  else if(fallState == 40){

    bodyModel->setTargetAngle(EFF_LL1, -20.0);
    bodyModel->setTargetAngle(EFF_RL1, -20.0);

    if(bodyModel->targetsReached()){
      fallState = 41;
    }
  }
  else if(fallState < 50){
    fallState++;
  }
  else if(fallState == 50){

    bodyModel->setTargetAngle(EFF_LL1, 0);
    bodyModel->setTargetAngle(EFF_RL1, 0);

    if(bodyModel->targetsReached()){
      fallState = 51;
    }
  }
  else if(fallState < 60){
    fallState++;
  }
  else if(fallState == 60){

    bodyModel->setTargetAngle(EFF_LL3, 70.0);
    bodyModel->setTargetAngle(EFF_RL3, 70.0);

    bodyModel->setTargetAngle(EFF_LL4, -40.0);
    bodyModel->setTargetAngle(EFF_RL4, -40.0);

    if(bodyModel->targetsReached()){
      fallState = 61;
    }
  }
  else if(fallState < 65){
    fallState++;
  }
  else if(fallState == 65){

    bodyModel->setTargetAngle(EFF_LL3, 30.0);
    bodyModel->setTargetAngle(EFF_RL3, 30.0);

    bodyModel->setTargetAngle(EFF_LL5, 25.0);
    bodyModel->setTargetAngle(EFF_RL5, 25.0);

    bodyModel->setTargetAngle(EFF_LA1, -35.0);
    bodyModel->setTargetAngle(EFF_RA1, -35.0);

    if(bodyModel->targetsReached()){
      fallState = 66;
    }
  }
  else if(fallState < 70){
    fallState++;
  }
  else if(fallState == 70){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);

    if(bodyModel->targetsReached()){
      fallState = 0;
      fallenDown = false;
    }
  }
}

