#include "naobehavior.h"

extern map<string,float> namedParams;

void NaoBehavior::walk_front(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, namedParams["L3target1"]); //15.0
    bodyModel->increaseTargetAngle(EFF_LL4, namedParams["L4target1"]); //-30.0
    bodyModel->increaseTargetAngle(EFF_LL5, namedParams["L5target1"]); //15.0
  }
  else if(skillState == 4){
        
    bodyModel->increaseTargetAngle(EFF_LL3, namedParams["L3target2"]); //30.0
    bodyModel->increaseTargetAngle(EFF_LL5, namedParams["L5target2"]); //-30.0
  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, namedParams["L3target1"]); //15.0
    bodyModel->increaseTargetAngle(EFF_RL4, namedParams["L4target1"]); //-30.0
    bodyModel->increaseTargetAngle(EFF_RL5, namedParams["L5target1"]); //15.0
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, namedParams["L3target2"]); //30.0
    bodyModel->increaseTargetAngle(EFF_RL5, namedParams["L5target2"]); //-30.0
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_back(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 30.0);
  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 30.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_left(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL2, 11.0);
    bodyModel->increaseTargetAngle(EFF_LL6, -11.0);

    bodyModel->increaseTargetAngle(EFF_LL1, -3.5);
  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL2, 11.0);
    bodyModel->increaseTargetAngle(EFF_RL6, -11.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::walk_right(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL2, -11.0);
    bodyModel->increaseTargetAngle(EFF_LL6, 11.0);

  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL2, -11.0);
    bodyModel->increaseTargetAngle(EFF_RL6, 11.0);

    bodyModel->increaseTargetAngle(EFF_RL1, -3.5);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::turn_left(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 20.0);

  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, -20.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::turn_right(){

  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, -20.0);
  }
  else if(skillState == 10){
      
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 20.0);
  }

  skillState = (skillState + 1) % 20;
}

void NaoBehavior::kick_front(){
  
  // Standing straight
  if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);

    if(bodyModel->targetsReached()){
      skillState = 1; 
    }
  }
  else if(skillState < 25){
    // Stay for 25 cycles, allow time to straighten
    skillState++;
  }
  else if(skillState == 25){
    
    if(kickLeg == LEG_RIGHT){
      // Set angle of foot and hip of symmetric leg to kick -- for balance
      bodyModel->setTargetAngle(EFF_LL2, -10.0);
      bodyModel->setTargetAngle(EFF_LL6, 10.0);
    }
    else{
      bodyModel->setTargetAngle(EFF_RL2, 10.0);
      bodyModel->setTargetAngle(EFF_RL6, -10.0);
    }
    
    //crouch down?
    bodyModel->increaseTargetAngle(EFF_LL3, 10.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 10.0);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 10.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 10.0);
    
    skillState = 26; 
  }
  else if(skillState == 26){
    // wait until targets reached
    if(bodyModel->targetsReached()){
      skillState = 27; 
    }
  }
  else if(skillState == 27){
    
    // Inverse kinematics:
    
    VecPosition temp = ball - (kickDirection * 0.18);
    temp.setZ(0.05); //namedParams["targetHeight"];
    
    // point where center of the foot should end up
    VecPosition localTarget = worldModel->g2l(temp);
    double angle = 0.0;	//namedParams["angleAtKick"];
    
    if(kickLeg == LEG_RIGHT){
      
      if(!(bodyModel->reachOutLeg(LEG_RIGHT, localTarget, angle))){
	
	//localTarget = VecPosition(-0.02, -0.08, -0.29);
	//angle = 0;
	//bodyModel->reachOutLeg(LEG_RIGHT, localTarget, angle);
	
	//Equivalent
	bodyModel->setTargetAngle(EFF_RL1, 0);
	bodyModel->setTargetAngle(EFF_RL2, -10.0);
	bodyModel->setTargetAngle(EFF_RL3, 25.0);
	bodyModel->setTargetAngle(EFF_RL4, -95.0);
	bodyModel->setTargetAngle(EFF_RL5, 70.0);
	bodyModel->setTargetAngle(EFF_RL6, 10.0);
	
      }
      
      bodyModel->increaseTargetAngle(EFF_RL5, -10.0);
    }
    else{
      
      //bodyModel->setScale(EFF_LL1, namedParams["forwardKickScaleLL1"]);
      //bodyModel->setScale(EFF_LL2, namedParams["forwardKickScaleLL2"]);
      //bodyModel->setScale(EFF_LL3, namedParams["forwardKickScaleLL3"]);
      //bodyModel->setScale(EFF_LL4, namedParams["forwardKickScaleLL4"]);
      //bodyModel->setScale(EFF_LL5, namedParams["forwardKickScaleLL5"]);
      //bodyModel->setScale(EFF_LL6, namedParams["forwardKickScaleLL6"]);

      if(!(bodyModel->reachOutLeg(LEG_LEFT, localTarget, angle))){
	
	//	localTarget = VecPosition(-0.02, 0.08, -0.29);
	//	angle = 0;
	//	bodyModel->reachOutLeg(LEG_LEFT, localTarget, angle);
	
	//Equivalent
	bodyModel->setTargetAngle(EFF_LL1, 0);
	bodyModel->setTargetAngle(EFF_LL2, 10.0);
	bodyModel->setTargetAngle(EFF_LL3, 25.0);
	bodyModel->setTargetAngle(EFF_LL4, -95.0);
	bodyModel->setTargetAngle(EFF_LL5, 70.0);
	bodyModel->setTargetAngle(EFF_LL6, -10.0);
	
      }

      bodyModel->increaseTargetAngle(EFF_LL5, -10.0);
    }
    
    skillState = 28; 
  }
  else if(skillState == 28){
    
    if(bodyModel->targetsReached()){
      skillState = 29; 
    }
  }
  else if(skillState == 29){
    
    if(kickLeg == LEG_RIGHT){
      
      if(kickType == KICK_LONG){
        // Motor gain
	bodyModel->setScale(EFF_RL3, 2.0); //namedParams["returnKickScale"];
	bodyModel->setTargetAngle(EFF_RL3, 100.0); //MAX
      }
      else{//kickType == KICK_SHORT
	bodyModel->setTargetAngle(EFF_RL3, 60.0);
      }


      bodyModel->setTargetAngle(EFF_RL4, 0);
      bodyModel->setTargetAngle(EFF_RL5, 0);
    }    
    else{

      if(kickType == KICK_LONG){
	bodyModel->setScale(EFF_LL3, 2.0); //namedParams["returnKickScale"]);
	bodyModel->setTargetAngle(EFF_LL3, 100.0);
      }
      else{//kickType == KICK_SHORT
	bodyModel->setTargetAngle(EFF_LL3, 60.0);
      }

      bodyModel->setTargetAngle(EFF_LL4, 0);
      bodyModel->setTargetAngle(EFF_LL5, 0);
    }

    if(bodyModel->targetsReached()){
      skillState = 30; 

      bodyModel->setScale(EFF_LL3, 1.0);
      bodyModel->setScale(EFF_RL3, 1.0);
    }
  }
  else if(skillState == 30){
    
    if(kickLeg == LEG_RIGHT){
      bodyModel->setTargetAngle(EFF_RL3, 40.0);
      bodyModel->setTargetAngle(EFF_RL4, -60.0);
      bodyModel->setTargetAngle(EFF_RL5, 20.0);
    }    
    else{
      bodyModel->setTargetAngle(EFF_LL3, 40.0);
      bodyModel->setTargetAngle(EFF_LL4, -60.0);
      bodyModel->setTargetAngle(EFF_LL5, 20.0);
    }
    if(bodyModel->targetsReached()){
      skillState = 31; 
    }
  }
  else if(skillState == 31){
    
    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    if(bodyModel->targetsReached()){
      skillState = 32; 
    }
  }
  else if(skillState < 50){
    skillState++;
  }
  else if(skillState == 50){
    skillState = 0;
  }
  
}

void NaoBehavior::stand(){

  setInitialHead();
  setInitialArm(ARM_LEFT);
  setInitialArm(ARM_RIGHT);
  setInitialLeg(LEG_LEFT);
  setInitialLeg(LEG_RIGHT);
  
  skillState = (skillState + 1) % 10;
}

void NaoBehavior::find_ball_left() {
  /*if(skillState == 0){

    setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
    
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_LL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_LL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 15.0);
    bodyModel->setTargetAngle(EFF_H2, -33);
    
  }
  else if(skillState == 4){
    
    bodyModel->increaseTargetAngle(EFF_LL3, -20.0);
    bodyModel->increaseTargetAngle(EFF_LL5, 20.0);

  }
  else if(skillState == 10){
      
    //setInitialHead();
    setInitialArm(ARM_LEFT);
    setInitialArm(ARM_RIGHT);
      
    setInitialLeg(LEG_LEFT);
    setInitialLeg(LEG_RIGHT);
    
    bodyModel->increaseTargetAngle(EFF_RL3, 15.0);
    bodyModel->increaseTargetAngle(EFF_RL4, -30.0);
    bodyModel->increaseTargetAngle(EFF_RL5, 15.0);
    //bodyModel->setTargetAngle(EFF_H2, 0);
  }
  else if(skillState == 14){
      
    bodyModel->increaseTargetAngle(EFF_RL3, 20.0);
    bodyModel->increaseTargetAngle(EFF_RL5, -20.0);
    }
  
  if (skillState < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
  }

  skillState = (skillState + 1) % 20;*/
  turn_left();

  if (skillState-1 == 0) {
    bodyModel->setTargetAngle(EFF_H2, -33);
  } else if (skillState-1 == 10) {
    bodyModel->setTargetAngle(EFF_H2, 3);
  }
  if (skillState-1 < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
  }
  
}

void NaoBehavior::find_ball_right() {
  turn_right();

  if (skillState-1 == 0) {
    bodyModel->setTargetAngle(EFF_H2, -33);
  } else if (skillState-1 == 10) {
    bodyModel->setTargetAngle(EFF_H2, 3);
  }
  if (skillState-1 < 10) {
    bodyModel->increaseTargetAngle(EFF_H2, 3);
  } else {
    bodyModel->increaseTargetAngle(EFF_H2, -3);
  }
}
